



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Lucene学习笔记： 四，Lucene索引过程分析</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Lucene学习笔记： 四，Lucene索引过程分析</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-18 20:38:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>对于Lucene的索引过程，除了将词(Term)写入倒排表并最终写入Lucene的索引文件外，还包括分词(Analyzer)和合并段(merge segments)的过程，本次不包括这两部分，将在以后的文章中进行分析。</p>
<p>Lucene的索引过程，很多的博客，文章都有介绍，推荐大家上网搜一篇文章：《Annotated Lucene》，好像中文名称叫《Lucene源码剖析》是很不错的。</p>
<p>想要真正了解Lucene索引文件过程，最好的办法是跟进代码调试，对着文章看代码，这样不但能够最详细准确的掌握索引过程(描述都是有偏差的，而代码是不会骗你的)，而且还能够学习Lucene的一些优秀的实现，能够在以后的工作中为我所用，毕竟Lucene是比较优秀的开源项目之一。</p>
<p>由于Lucene已经升级到3.0.0了，本索引过程为Lucene 3.0.0的索引过程。</p>
<h2><strong>一、索引过程体系结构</strong></h2>
<p>Lucene 3.0的搜索要经历一个十分复杂的过程，各种信息分散在不同的对象中分析，处理，写入，为了支持多线程，每个线程都创建了一系列类似结构的对象集，为了提高效率，要复用一些对象集，这使得索引过程更加复杂。</p>
<p>其实索引过程，就是经历下图中所示的索引链的过程，索引链中的每个节点，负责索引文档的不同部分的信息 ，当经历完所有的索引链的时候，文档就处理完毕了。最初的索引链，我们称之<strong>基本索引链</strong>。</p>
<p>为了支持多线程，使得多个线程能够并发处理文档，因而每个线程都要建立自己的索引链体系，使得每个线程能够独立工作，在基本索引链基础上建立起来的每个线程独立的索引链体系，我们称之<strong>线程索引链</strong>。线程索引链的每个节点是由基本索引链中的相应的节点调用函数addThreads创建的。</p>
<p>为了提高效率，考虑到对相同域的处理有相似的过程，应用的缓存也大致相当，因而不必每个线程在处理每一篇文档的时候都重新创建一系列对象，而是复用这些对象。所以对每个域也建立了自己的索引链体系，我们称之<strong>域索引链</strong>。域索引链的每个节点是由线程索引链中的相应的节点调用addFields创建的。</p>
<p>当完成对文档的处理后，各部分信息都要写到索引文件中，写入索引文件的过程是同步的，不是多线程的，也是沿着基本索引链将各部分信息依次写入索引文件的。</p>
<p>下面详细分析这一过程。</p>
<h2><strong>二、详细索引过程</strong></h2>
<h3><strong>1、创建IndexWriter对象</strong></h3>
<p>代码：</p>
<table>
<tbody>
<tr>
<td>IndexWriter writer = new IndexWriter(FSDirectory.open(INDEX_DIR), new StandardAnalyzer(Version.LUCENE_CURRENT), true, IndexWriter.MaxFieldLength.LIMITED);</td>
</tr>
</tbody>
</table>
<p>IndexWriter对象主要包含以下几方面的信息：</p>
<ul><li>用于索引文档</p>
<ul><li>Directory directory;&nbsp; 指向索引文件夹</li>
<li>Analyzer analyzer;&nbsp;&nbsp;&nbsp; 分词器</li>
<li>Similarity similarity = Similarity.getDefault(); 影响打分的标准化因子(normalization factor)部分，对文档的打分分两个部分，一部分是索引阶段计算的，与查询语句无关，一部分是搜索阶段计算的，与查询语句相关。</li>
<li>SegmentInfos segmentInfos = new SegmentInfos(); 保存段信息，大家会发现，和segments_N中的信息几乎一一对应。</li>
<li>IndexFileDeleter deleter; 此对象不是用来删除文档的，而是用来管理索引文件的。</li>
<li>Lock writeLock; 每一个索引文件夹只能打开一个IndexWriter，所以需要锁。</li>
<li>Set&lt;SegmentInfo&gt; segmentsToOptimize = new HashSet&lt;SegmentInfo&gt;(); 保存正在最优化(optimize)的段信息。当调用optimize的时候，当前所有的段信息加入此Set，此后新生成的段并不参与此次最优化。</li></ul></li>
<li>用于合并段，在合并段的文章中将详细描述
<ul><li>SegmentInfos localRollbackSegmentInfos;</li>
<li>HashSet&lt;SegmentInfo&gt; mergingSegments = new HashSet&lt;SegmentInfo&gt;();</li>
<li>MergePolicy mergePolicy = new LogByteSizeMergePolicy(this);</li>
<li>MergeScheduler mergeScheduler = new ConcurrentMergeScheduler();</li>
<li>LinkedList&lt;MergePolicy.OneMerge&gt; pendingMerges = new LinkedList&lt;MergePolicy.OneMerge&gt;();</li>
<li>Set&lt;MergePolicy.OneMerge&gt; runningMerges = new HashSet&lt;MergePolicy.OneMerge&gt;();</li>
<li>List&lt;MergePolicy.OneMerge&gt; mergeExceptions = new ArrayList&lt;MergePolicy.OneMerge&gt;();</li>
<li>long mergeGen;</li></ul></li>
<li>为保持索引完整性，一致性和事务性
<ul><li>SegmentInfos rollbackSegmentInfos; 当IndexWriter对索引进行了添加，删除文档操作后，可以调用commit将修改提交到文件中去，也可以调用rollback取消从上次commit到此时的修改。</li>
<li>SegmentInfos localRollbackSegmentInfos; 此段信息主要用于将其他的索引文件夹合并到此索引文件夹的时候，为防止合并到一半出错可回滚所保存的原来的段信息。</li></ul></li>
<li>一些配置
<ul><li>long writeLockTimeout; 获得锁的时间超时。当超时的时候，说明此索引文件夹已经被另一个IndexWriter打开了。</li>
<li>int termIndexInterval; 同tii和tis文件中的indexInterval。</li></ul></li></ul>
<h3><strong>2、创建文档Document对象，并加入域(Field)</strong></h3>
<p>代码：</p>
<table>
<tbody>
<tr>
<td>
<p>Document doc = new Document();</p>
<p>doc.add(new Field("path", f.getPath(), Field.Store.YES, Field.Index.NOT_ANALYZED));</p>
<p>doc.add(new Field("modified",DateTools.timeToString(f.lastModified(), DateTools.Resolution.MINUTE), Field.Store.YES, Field.Index.NOT_ANALYZED));</p>
<p>doc.add(new Field("contents", new FileReader(f)));</p>
</td>
</tr>
</tbody>
</table>
<p>Document对象主要包括以下部分：</p>
<ul><li>此文档的boost，默认为1，大于一说明比一般的文档更加重要，小于一说明更不重要。</li>
<li>一个ArrayList保存此文档所有的域</li>
<li>每一个域包括域名，域值，和一些标志位，和fnm，fdx，fdt中的描述相对应。</li></ul>
<h3><strong>3、将文档加入IndexWriter</strong></h3>
<p>代码：</p>
<table>
<tbody>
<tr>
<td>writer.addDocument(doc);&nbsp;<br />--&gt;IndexWriter.addDocument(Document doc, Analyzer analyzer)&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp; --&gt;doFlush = docWriter.addDocument(doc, analyzer);&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; --&gt; DocumentsWriter.updateDocument(Document, Analyzer, Term)&nbsp;<br /><strong>注：--&gt; 代表一级函数调用</strong></td>
</tr>
</tbody>
</table>
<p>IndexWriter继而调用DocumentsWriter.addDocument，其又调用DocumentsWriter.updateDocument。</p>
<h3><strong>4、将文档加入DocumentsWriter</strong></h3>
<p>代码：</p>
<table>
<tbody>
<tr>
<td>DocumentsWriter.updateDocument(Document doc, Analyzer analyzer, Term delTerm)&nbsp;<br />--&gt;(1) DocumentsWriterThreadState state = getThreadState(doc, delTerm);&nbsp;<br />--&gt;(2) DocWriter perDoc = state.consumer.processDocument();&nbsp;<br />--&gt;(3) finishDocument(state, perDoc);</td>
</tr>
</tbody>
</table>
<p>DocumentsWriter对象主要包含以下几部分：</p>
<ul><li>用于写索引文件</p>
<ul><li>IndexWriter writer;</li>
<li>Directory directory;</li>
<li>Similarity similarity：分词器</li>
<li>String segment：当前的段名，每当flush的时候，将索引写入以此为名称的段。</li></ul></li></ul>
<table>
<tbody>
<tr>
<td>IndexWriter.doFlushInternal()&nbsp;<br />--&gt; String segment = docWriter.getSegment();//return segment&nbsp;<br />--&gt; newSegment = new SegmentInfo(segment,&hellip;&hellip;);&nbsp;<br />--&gt; docWriter.createCompoundFile(segment);//根据segment创建cfs文件。</td>
</tr>
</tbody>
</table>
<ul><ul><li>String docStoreSegment：存储域所要写入的目标段。(在索引文件格式一文中已经详细描述)</li>
<li>int docStoreOffset：存储域在目标段中的偏移量。</li>
<li>int nextDocID：下一篇添加到此索引的文档ID号，对于同一个索引文件夹，此变量唯一，且同步访问。</li>
<li>DocConsumer consumer; 这是整个索引过程的核心，是IndexChain整个索引链的源头。</li></ul></ul>
<h3><strong>5、DocumentsWriter对CharBlockPool，ByteBlockPool，IntBlockPool的缓存管理</strong></h3>
<ul><li>在索引的过程中，DocumentsWriter将词信息(term)存储在CharBlockPool中，将文档号(doc ID)，词频(freq)和位置(prox)信息存储在ByteBlockPool中。</li>
<li>在ByteBlockPool中，缓存是分块(slice)分配的，块(slice)是分层次的，层次越高，此层的块越大，每一层的块大小事相同的。
<ul><li>nextLevelArray表示的是当前层的下一层是第几层，可见第9层的下一层还是第9层，也就是说最高有9层。</li>
<li>levelSizeArray表示每一层的块大小，第一层是5个byte，第二层是14个byte以此类推。</li></ul></li></ul>
<table>
<tbody>
<tr>
<td>
<p>ByteBlockPool类中有以下静态变量：</p>
<p>final static int[] nextLevelArray = {1, 2, 3, 4, 5, 6, 7, 8, 9, 9};&nbsp;<br />final static int[] levelSizeArray = {5, 14, 20, 30, 40, 40, 80, 80, 120, 200};</p>
</td>
</tr>
</tbody>
</table>
<h3><strong>6、关闭IndexWriter对象</strong></h3>
<p>代码：</p>
<table>
<tbody>
<tr>
<td>
<p>writer.close();</p>
<p>--&gt; IndexWriter.closeInternal(boolean)</p>
<p>--&gt; (1) 将索引信息由内存写入磁盘: flush(waitForMerges, true, true);&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; --&gt; (2) 进行段合并: mergeScheduler.merge(this);</p>
</td>
</tr>
</tbody>
</table>
<p>对段的合并将在后面的章节进行讨论，此处仅仅讨论将索引信息由写入磁盘的过程。</p>
<p>代码：</p>
<table>
<tbody>
<tr>
<td>
<p>IndexWriter.flush(boolean triggerMerge, boolean flushDocStores, boolean flushDeletes)</p>
<p>--&gt; IndexWriter.doFlush(boolean flushDocStores, boolean flushDeletes)</p>
<p>--&gt; IndexWriter.doFlushInternal(boolean flushDocStores, boolean flushDeletes)</p>
</td>
</tr>
</tbody>
</table>
<p>将索引写入磁盘包括以下几个过程：</p>
<ul><li>得到要写入的段名：String segment = docWriter.getSegment();</li>
<li>DocumentsWriter将缓存的信息写入段：docWriter.flush(flushDocStores);</li>
<li>生成新的段信息对象：newSegment = new SegmentInfo(segment, flushedDocCount, directory, false, true, docStoreOffset, docStoreSegment, docStoreIsCompoundFile, docWriter.hasProx());</li>
<li>准备删除文档：docWriter.pushDeletes();</li>
<li>生成cfs段：docWriter.createCompoundFile(segment);</li>
<li>删除文档：applyDeletes();</li></ul>
<h4><strong>6.1、得到要写入的段名</strong></h4>
<p>代码：</p>
<table>
<tbody>
<tr>
<td>
<p>SegmentInfo newSegment = null;</p>
<p>final int numDocs = docWriter.getNumDocsInRAM();//文档总数</p>
<p>String docStoreSegment = docWriter.getDocStoreSegment();//存储域和词向量所要要写入的段名，"_0"</p>
<p>int docStoreOffset = docWriter.getDocStoreOffset();//存储域和词向量要写入的段中的偏移量</p>
<p>String segment = docWriter.getSegment();//段名，"_0"</p>
</td>
</tr>
</tbody>
</table>
<p>在Lucene的索引文件结构一章做过详细介绍，存储域和词向量可以和索引域存储在不同的段中。</p>
<h4><strong>6.2、将缓存的内容写入段</strong></h4>
<p>代码：</p>
<table>
<tbody>
<tr>
<td>
<p>flushedDocCount = docWriter.flush(flushDocStores);</p>
</td>
</tr>
</tbody>
</table>
<p>此过程又包含以下两个阶段；</p>
<ul><li>按照基本索引链关闭存储域和词向量信息</li>
<li>按照基本索引链的结构将索引结果写入段</li></ul>
<div>
<h4><strong>6.3、生成新的段信息对象</strong></h4>
<p>代码：</p>
<table>
<tbody>
<tr>
<td>
<p>newSegment = new SegmentInfo(segment, flushedDocCount, directory, false, true, docStoreOffset, docStoreSegment, docStoreIsCompoundFile, docWriter.hasProx());</p>
<p>segmentInfos.add(newSegment);</p>
</td>
</tr>
</tbody>
</table>
<h4><strong>6.4、准备删除文档</strong></h4>
<p>代码：</p>
<table>
<tbody>
<tr>
<td>
<p>docWriter.pushDeletes();</p>
<p>--&gt; deletesFlushed.update(deletesInRAM);</p>
</td>
</tr>
</tbody>
</table>
<p>此处将deletesInRAM全部加到deletesFlushed中，并把deletesInRAM清空。原因上面已经阐明。</p>
<h4><strong>6.5、生成cfs段</strong></h4>
<p>代码：</p>
<table>
<tbody>
<tr>
<td>
<p>docWriter.createCompoundFile(segment);</p>
<p>newSegment.setUseCompoundFile(true);</p>
</td>
</tr>
</tbody>
</table>
<p>代码为：</p>
<table>
<tbody>
<tr>
<td>
<p>DocumentsWriter.createCompoundFile(String segment) {</p>
<p>CompoundFileWriter cfsWriter = new CompoundFileWriter(directory, segment + "." + IndexFileNames.COMPOUND_FILE_EXTENSION);</p>
<p>//将上述中记录的文档名全部加入cfs段的写对象。</p>
<p>for (final String flushedFile : flushState.flushedFiles)</p>
<p>cfsWriter.addFile(flushedFile);</p>
<p>cfsWriter.close();</p>
<p>}</p>
</td>
</tr>
</tbody>
</table>
<h4><strong>6.6、删除文档</strong></h4>
<p>代码：</p>
<table>
<tbody>
<tr>
<td>
<p>applyDeletes();</p>
</td>
</tr>
</tbody>
</table>
<p>代码为：</p>
<table>
<tbody>
<tr>
<td>
<p>boolean applyDeletes(SegmentInfos infos) {</p>
<p>if (!hasDeletes())</p>
<p>return false;</p>
<p>final int infosEnd = infos.size();</p>
<p>int docStart = 0;</p>
<p>boolean any = false;</p>
<p>for (int i = 0; i &lt; infosEnd; i++) {</p>
<p>assert infos.info(i).dir == directory;</p>
<p>SegmentReader reader = writer.readerPool.get(infos.info(i), false);</p>
<p>try {</p>
<p>any |= applyDeletes(reader, docStart);</p>
<p>docStart += reader.maxDoc();</p>
<p>} finally {</p>
<p>writer.readerPool.release(reader);</p>
<p>}</p>
<p>}</p>
<p>deletesFlushed.clear();</p>
<p>return any;</p>
<p>}</p>
</td>
</tr>
</tbody>
</table>
<ul><li>Lucene删除文档可以用reader，也可以用writer，但是归根结底还是用reader来删除的。</li>
<li>reader的删除有以下三种方式：
<ul><li>按照词删除，删除所有包含此词的文档。</li>
<li>按照文档号删除。</li>
<li>按照查询对象删除，删除所有满足此查询的文档。</li></ul></li>
<li>但是这三种方式归根结底还是按照文档号删除，也就是写.del文件的过程。</li></ul>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq44v2eq.html">Daily Scrum Meeting &mdash;&mdash;FifthDay</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4mlrjq.html">Node&period;js怎么处理数据库中日期类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlx3rxq.html">PAT 1003&period; 我要通过！&lpar;20&rpar; JAVA</a>
		</li>
						<li><a href="https://www.batexi.com/a/495yxpmq.html">android之服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq135k58.html">GEF - 制作一个简单图形化编辑框架笔记1</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2r5pv9.html">将JSON转成DataSet（DataTable）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdkoez8.html">Java中的数组操作进阶</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnpzl6q.html">kettle菜鸟学习笔记1----相关准备知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1r3g59.html">【转载】Android Studio 设置内存大小及原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ogd2y9.html">maven安装步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjd7lk8.html">constraint 摘自群主大大</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jznmog8.html">Docker - 容器编排工具 compose 之安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mpx2m8.html">java学习&mdash;&mdash;平台的安装与部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/90myow38.html">BYS推荐MS前端PhoneCall面试问题整理-2</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k17149.html">Gradle 学习一</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25g1klq.html">Spring Boot&sol;Spring Cloud</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjwep7q.html">栈的实现与操作&lpar;C语言实现&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ply3eq.html">实现一个 RESTful API 服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8koxjk3q.html">20155302 2016-2017-2 《Java程序设计》 第1周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qd5wm6v9.html">Hbase集群部署及shell操作</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95xw10m8.html">几种C&num;程序读取MAC地址的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xv2zr9.html">&lbrack;转&rsqb;更新Debian软件源</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oyemy9.html">自定义View&lpar;1&rpar;简单流程及示例模板</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0250lq.html">&lbrack;POJ2377&rsqb;Bad Cowtractors&lpar;最大生成树，Kruskal&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1jn5m9.html">poj 1191 棋盘分割&lpar;dp &plus; 记忆化搜索&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn51mj8.html">Dapper使用在WCF上总是说Service找不到</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okg76l9.html">UVa 524 Prime Ring Problem【回溯】</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1jpxj9.html">PHP查询数据库中满足条件的记录条数&lpar;二种实现方法&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnwov6q.html">Tomcat 映射虚拟目录</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xdx4v8.html">【CSS】css各种居中方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
